#include <ilcplex/ilocplex.h>
#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <iostream>


#define BILLION 1000000000L

typedef struct timespec timespec_t;

ILOSTLBEGIN

int CLSD_trad(IloEnv env, int T, int J, IloNumArray a, IloNumArray h, IloArray <IloNumArray> b, IloArray <IloNumArray> sc, IloArray <IloNumArray> st, IloArray <IloNumArray> d, IloNumArray K, IloNumArray isetup, IloNumArray istock, IloArray <IloArray <IloBoolVarArray> >  *z, IloArray <IloBoolVarArray> *y, IloModel *modelo) {

	*modelo = IloModel(env);

	IloArray <IloNumVarArray> x(env,J), V(env,J), I(env,J);
	*y = IloArray <IloBoolVarArray> (env,J);
	for(int j = 0; j < J; ++j) {
		x[j] = IloNumVarArray(env,T,0,IloInfinity);
		V[j] = IloNumVarArray(env,T,0,IloInfinity);
		I[j] = IloNumVarArray(env,T,0,IloInfinity);
		(*y)[j] = IloBoolVarArray(env,T);
	}
	*z = IloArray <IloArray <IloBoolVarArray> > (env,J);
	for(int i = 0; i < J; ++i) {
		(*z)[i] = IloArray <IloBoolVarArray> (env,J);
		for(int j = 0; j < J; ++j) {
			(*z)[i][j] = IloBoolVarArray (env,T);
		}
	}
	IloBoolVarArray yfinal(env,J);
	IloExpr fo1(env);
	for(int t = 0; t < T; ++t) {
		for(int j = 0; j < J; ++j) {
			fo1 += h[j]*I[j][t];
		}
	}
	IloExpr fo2(env);
	for(int i = 0; i < J; ++i) {
		for(int j = 0; j < J; ++j) {
			for(int t = 0; t < T; ++t) {
				fo2 += sc[i][j]*(*z)[i][j][t];
			}
		}
	}
	modelo->add(IloMinimize(env,fo1+fo2));
	fo1.end(); fo2.end();
	for(int t = 1; t < T; ++t) {
		for(int j = 0; j < J; ++j) {
			modelo->add(I[j][t] - I[j][t-1] - x[j][t] == - d[j][t]);
		}
	}
	for(int j = 0; j < J; ++j) {
		modelo->add(I[j][0] - x[j][0] - istock[j] ==  - d[j][0]);
	}
	for(int t = 0; t < T; ++t) {
		IloExpr expr1(env);
		for(int j = 0; j < J; ++j) {
			expr1 += a[j]*x[j][t];
		}
		IloExpr expr2(env);
		for(int i = 0; i < J; ++i) {
			for(int j = 0; j < J; ++j) {
				expr2 += st[i][j]*(*z)[i][j][t];
			}
		}
		modelo->add(expr1 + expr2 <= K[t]);
		expr1.end();
		expr2.end();
	}

	for(int t = 0; t < T; ++t) {
		for(int j = 0; j < J; ++j) {
			IloExpr fluxo(env);
			for(int i = 0; i < J; ++i) {
		//		if (i != j) {
					fluxo += (*z)[i][j][t];
		//		}
			}
			modelo->add(x[j][t] <= b[j][t]*(fluxo + (*y)[j][t]));
			fluxo.end();
		}
	}
	for(int t = 0; t < T; ++t) {
		IloExpr ini(env);
		for(int j = 0; j < J; ++j) {
			ini += (*y)[j][t];
		}
		modelo->add(ini == 1);
		ini.end();
	}

	for(int j = 0; j < J; ++j) {
		modelo->add((*y)[j][0] == isetup[j]);
	}

	for(int j = 0; j < J; ++j) {
		for(int t = 0; t < T-1; ++t) {
			IloExpr cons(env);
			for(int i = 0; i < J; ++i) {
				if (i != j) {
					cons += (*z)[i][j][t];
				}
			}
			IloExpr cons2(env);
			for(int i = 0; i < J; ++i) {
				if (i != j) {
					cons2 += (*z)[j][i][t];
				}
			}
			modelo->add((*y)[j][t] + cons == cons2 + (*y)[j][t+1]);
			cons.end();
			cons2.end();
		}
	}
	for(int j = 0; j < J; ++j) {
		IloExpr cons3(env);
		for(int i = 0; i < J; ++i) {
			if(i != j) {
				cons3 += (*z)[i][j][T-1];
			}
		}
		IloExpr cons4(env);
		for(int i = 0; i < J; ++i) {
			if(i != j) {
				cons4 += (*z)[j][i][T-1];
			}
		}
		modelo->add((*y)[j][T-1] + cons3 == cons4 + yfinal[j]);
		cons3.end();
		cons4.end();
	}	

	for(int j = 0; j < J; ++j) {
		for(int t = 0; t < T; ++t) {
			IloExpr chega(env);
			for(int i = 0; i < J; ++i) {
				if (i != j) {
					chega += (*z)[i][j][t];
				}
			}
			modelo->add((*y)[j][t] + chega <= 1);
			chega.end();
		}
	}

	for(int i = 0; i < J; ++i) {
		for(int j = 0; j < J; ++j) {
			for(int t = 0; t < T; ++t) {
				modelo->add(V[j][t] >= V[i][t] + 1 - J*(1 - (*z)[i][j][t]));
			}
		}
	}
	for(int j = 0; j < J; ++j) {
		for(int t = 0; t < T; ++t) {
			IloExpr e(env); IloExpr sai(env);
			for(int i = 0; i < J; ++i) {
				e += (*z)[i][j][t];
				sai += (*z)[j][i][t];
			}
			modelo->add(e <= 1);
			modelo->add(sai <= 1);
			e.end(); sai.end();
		}
	}
	for(int j = 0; j < J; ++j) {
		for(int t = 0; t < T; ++t) {
			(*z)[j][j][t].setUB(0);
			(*z)[j][t][t].setLB(0);
		}
	}
	
return 0;
}

int CLSD_w(IloEnv env, int T, int J, IloNumArray a, IloNumArray h, IloArray <IloNumArray> b, IloArray <IloNumArray> sc, IloArray <IloNumArray> st, IloArray <IloNumArray> d, IloNumArray K, IloNumArray isetup, IloNumArray istock, IloArray <IloArray <IloBoolVarArray> >  *z, IloArray <IloBoolVarArray> *y, IloArray <IloBoolVarArray> *w, IloModel *modelo) {

	*modelo = IloModel(env);

	IloArray <IloNumVarArray> x(env,J), V(env,J), I(env,J);
	*w = IloArray <IloBoolVarArray> (env,J);
	*y = IloArray <IloBoolVarArray> (env,J);
	for(int j = 0; j < J; ++j) {
		x[j] = IloNumVarArray(env,T,0,IloInfinity);
		V[j] = IloNumVarArray(env,T,0,IloInfinity);
		I[j] = IloNumVarArray(env,T,0,IloInfinity);
		(*y)[j] = IloBoolVarArray(env,T);
		(*w)[j] = IloBoolVarArray(env,T);
	}
	*z = IloArray <IloArray <IloBoolVarArray> > (env,J);
	for(int i = 0; i < J; ++i) {
		(*z)[i] = IloArray <IloBoolVarArray> (env,J);
		for(int j = 0; j < J; ++j) {
			(*z)[i][j] = IloBoolVarArray (env,T);
		}
	}
	IloBoolVarArray yfinal(env,J);
	IloExpr fo1(env);
	for(int t = 0; t < T; ++t) {
		for(int j = 0; j < J; ++j) {
			fo1 += h[j]*I[j][t];
		}
	}
	IloExpr fo2(env);
	for(int i = 0; i < J; ++i) {
		for(int j = 0; j < J; ++j) {
			for(int t = 0; t < T; ++t) {
				fo2 += sc[i][j]*(*z)[i][j][t];
			}
		}
	}
	modelo->add(IloMinimize(env,fo1+fo2));
	fo1.end(); fo2.end();
	for(int t = 1; t < T; ++t) {
		for(int j = 0; j < J; ++j) {
			modelo->add(I[j][t] - I[j][t-1] - x[j][t] == - d[j][t]);
		}
	}
	for(int j = 0; j < J; ++j) {
		modelo->add(I[j][0] - x[j][0] - istock[j] ==  - d[j][0]);
	}

	for(int t = 0; t < T; ++t) {
		IloExpr expr1(env);
		for(int j = 0; j < J; ++j) {
			expr1 += a[j]*x[j][t];
		}
		IloExpr expr2(env);
		for(int i = 0; i < J; ++i) {
			for(int j = 0; j < J; ++j) {
				expr2 += st[i][j]*(*z)[i][j][t];
			}
		}

		modelo->add(expr1 + expr2 <= K[t]);
		expr1.end();
		expr2.end();

	}

	for(int t = 0; t < T; ++t) {
		for(int j = 0; j < J; ++j) {
			IloExpr fluxo(env);
			for(int i = 0; i < J; ++i) {
				if (i != j) {
					fluxo += (*z)[i][j][t];
				}
			}
			modelo->add((*y)[j][t] + fluxo == (*w)[j][t]);
			fluxo.end();
		}
	}
	for(int j = 0; j < J; ++j) {
		for(int t = 0; t < T; ++t) {
			modelo->add(x[j][t] <= b[j][t]*(*w)[j][t]);
		}
	}
	for(int t = 0; t < T; ++t) {
		IloExpr ini(env);
		for(int j = 0; j < J; ++j) {
			ini += (*y)[j][t];
		}
		modelo->add(ini == 1);
		ini.end();
	}

	for(int j = 0; j < J; ++j) {
		modelo->add((*y)[j][0] == isetup[j]);
	}

	for(int j = 0; j < J; ++j) {
		for(int t = 0; t < T-1; ++t) {
			IloExpr cons(env);
			for(int i = 0; i < J; ++i) {
				if (i != j) {
					cons += (*z)[i][j][t];
				}
			}
			IloExpr cons2(env);
			for(int i = 0; i < J; ++i) {
				if (i != j) {
					cons2 += (*z)[j][i][t];
				}
			}
			modelo->add((*y)[j][t] + cons == cons2 + (*y)[j][t+1]);
			cons.end();
			cons2.end();
		}
	}
	for(int j = 0; j < J; ++j) {
		IloExpr cons3(env);
		for(int i = 0; i < J; ++i) {
			if(i != j) {
				cons3 += (*z)[i][j][T-1];
			}
		}
		IloExpr cons4(env);
		for(int i = 0; i < J; ++i) {
			if(i != j) {
				cons4 += (*z)[j][i][T-1];
			}
		}
		modelo->add((*y)[j][T-1] + cons3 == cons4 + yfinal[j]);
		cons3.end();
		cons4.end();
	}	

	for(int j = 0; j < J; ++j) {
		for(int t = 0; t < T; ++t) {
			IloExpr chega(env);
			for(int i = 0; i < J; ++i) {
				if (i != j) {
					chega += (*z)[i][j][t];
				}
			}
			modelo->add((*y)[j][t] + chega <= 1);
			chega.end();
		}
	}

	for(int i = 0; i < J; ++i) {
		for(int j = 0; j < J; ++j) {
			for(int t = 0; t < T; ++t) {
				modelo->add(V[j][t] >= V[i][t] + 1 - J*(1 - (*z)[i][j][t]));
			}
		}
	}
	for(int j = 0; j < J; ++j) {
		for(int t = 0; t < T; ++t) {
			IloExpr e(env); IloExpr sai(env);
			for(int i = 0; i < J; ++i) {
				e += (*z)[i][j][t];
				sai += (*z)[j][i][t];
			}
			modelo->add(e <= 1);
			modelo->add(sai <= 1);
			e.end(); sai.end();
		}
	}
	for(int j = 0; j < J; ++j) {
		for(int t = 0; t < T; ++t) {
			(*z)[j][j][t].setUB(0);
			(*z)[j][j][t].setLB(0);
		}
	}
	
return 0;
}



